#****************************************************************************
#**
#**  File     :  /cdimage/units/DAA0206/DAA0206_script.lua
#**  Author(s):  Dru Staltman, Eric Williamson, Gordon Duclos, Greg Kohne
#**
#**  Summary  :  Aeon Guided Missile Script
#**
#**  Copyright  2007 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************
local AAirUnit = import('/lua/aeonunits.lua').AAirUnit
local DefaultProjectileWeapon = import('/lua/sim/defaultweapons.lua').DefaultProjectileWeapon
local EffectTemplate = import('/lua/EffectTemplates.lua')
local EffectUtils = import('/lua/effectutilities.lua')

DAA0206 = Class(AAirUnit) {
    Weapons = {
        Suicide = Class(DefaultProjectileWeapon) {}
    },
    
    OnRunOutOfFuel = function(self)
        self:Kill()
    end,

    OnCreate = function(self)
        AAirUnit.OnCreate(self)
        self:ForkThread(self.LandingCheckThread)
    end, 
    

    LandingCheckThread = function(self)
        while not self:IsDead() do
            layer = self:GetCurrentLayer()
            if layer == 'Land' then        
                self:SetIntelRadius('Vision', 5)
            elseif layer == 'Air' then        
                self:SetIntelRadius('Vision', 150)
            end
            WaitTicks(1)
        end
    end,

   OnKilled = function(self, instigator, type, overkillRatio)
  	AAirUnit.OnKilled(self, instigator, type, overkillRatio)
    	self:KillThread(LandingCheckThread)
   end,


}
TypeClass = DAA0206


