#****************************************************************************
#**
#**  File     :  /cdimage/units/uas0203/uas0203_script.lua
#**  Author(s):  John Comes, Jessica St. Croix
#**
#**  Summary  :  Aeon Attack Sub Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local ASubUnit = import('/lua/aeonunits.lua').ASubUnit
local AANChronoTorpedoWeapon = import('/lua/aeonweapons.lua').AANChronoTorpedoWeapon

UAS0203 = Class(ASubUnit) {
    DeathThreadDestructionWaitTime = 0,
    Weapons = {
        Torpedo01 = Class(AANChronoTorpedoWeapon) {},
    },



    OnStopBeingBuilt = function(self, builder, layer)
        ASubUnit.OnStopBeingBuilt(self,builder,layer)
        if(self:GetCurrentLayer() == 'Water') then
           		 self:AddCommandCap('RULEUCC_CallTransport')
        elseif (self:GetCurrentLayer() == 'UnderWater') then
     			 self:RemoveCommandCap('RULEUCC_CallTransport')
       end
    end,



    OnMotionVertEventChange = function( self, new, old )
        ASubUnit.OnMotionVertEventChange(self, new, old)
        if new == 'Top' then
           		 self:AddCommandCap('RULEUCC_CallTransport')
        elseif new == 'Down' then
     			 self:RemoveCommandCap('RULEUCC_CallTransport')
        end
    end,
}

TypeClass = UAS0203