#****************************************************************************
#**
#**  File     :  /cdimage/units/UEB4203/UEB4203_script.lua
#**  Author(s):  David Tomandl, Jessica St. Croix
#**
#**  Summary  :  UEF Radar Jammer Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TRadarJammerUnit = import('/lua/terranunits.lua').TRadarJammerUnit

local Buff = import('/lua/sim/Buff.lua')
local EffectTemplate = import('/lua/EffectTemplates.lua')
local Entity = import('/lua/sim/Entity.lua').Entity
local AIUtils = import('/lua/AI/aiutilities.lua')


UEB4203 = Class(TRadarJammerUnit) {



    # New damage inducing thread
    RegenBuffThread = function(self)
        while not self:IsDead() do
            # Get friendly units in the area (including self)
	    local aiBrain = self:GetAIBrain()
            local units =  aiBrain:GetUnitsAroundPoint(categories.ALLUNITS, self:GetPosition(), 20000, 'Enemy')
           # Give them damage
            for _,unit in units do
		
		if unit:GetHealth() > 400 then
                  unit:DoTakeDamage(self,100,0,'Normal') 
		end
            end
            #Wait 5 seconds
            WaitSeconds(5)
        end
    end,




    OnStopBeingBuilt = function(self)
 
        TRadarJammerUnit.OnStopBeingBuilt(self)

        local army =  self:GetArmy()

               

        #table.insert( self.ShieldEffectsBag, CreateAttachedEmitter( self, 'UEC0001', self:GetArmy(), '/effects/emitters/seraphim_regenerative_aura_01_emit.bp' ) )
        self.RegenThreadHandle = self:ForkThread(self.RegenBuffThread)

    end,








    IntelEffects = {
		{
			Bones = {
				'UEB4203',
			},
			Offset = {
				0,
				0,
				3,
			},
			Type = 'Jammer01',
		},
    },
}

TypeClass = UEB4203