#****************************************************************************
#**
#**  File     :  /cdimage/units/UEC0001/UEC0001_script.lua
#**  Author(s):  John Comes
#**
#**  Summary  :  Operation E2 Civilian Transport Truck
#**
#**  Copyright  2006 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TLandUnit = import('/lua/terranunits.lua').TLandUnit
local Buff = import('/lua/sim/Buff.lua')
local EffectTemplate = import('/lua/EffectTemplates.lua')
local Entity = import('/lua/sim/Entity.lua').Entity
local AIUtils = import('/lua/AI/aiutilities.lua')


UEC0001 = Class(TLandUnit) {

	    AmbientEffects = 'ST2PowerAmbient',
	    ShieldEffects = {
        '/effects/emitters/seraphim_regenerative_aura_01_emit.bp',
    	},


    # Copy of XSL0001_script's RegenBuffThread with slight alterations (Enhancement and RegenField)
    RegenBuffThread = function(self)
        while not self:IsDead() do
            # Get friendly units in the area (including self)
            local units = AIUtils.GetOwnUnitsAroundPoint(self:GetAIBrain(), categories.ALLUNITS, self:GetPosition(), self:GetBlueprint().RegenAura.RegenRadius)
           # Give them a 5 second regen buff
            for _,unit in units do
                Buff.ApplyBuff(unit, 'RepairTruckAura')
            end
            #Wait 5 seconds
            WaitSeconds(5)
        end
    end,




    OnStopBeingBuilt = function(self)
 
        TLandUnit.OnStopBeingBuilt(self)

        if not self.ShieldEffectsBag then
            self.ShieldEffectsBag = {}
        end
        self.ShieldEffectsBag = {}
        local army =  self:GetArmy()
        if self.AmbientEffects then
            for k, v in EffectTemplate[self.AmbientEffects] do
				CreateAttachedEmitter(self, 'UEC0001', army, v):ScaleEmitter(1.2)
            end
        end
               
        local bp = self:GetBlueprint().RegenAura

        if not Buffs['RepairTruckAura'] then
            BuffBlueprint {
                Name = 'RepairTruckAura',
                DisplayName = 'RepairTruckAura',
                BuffType = 'ACUREGENERATEBONUS',
                Stacks = 'ALWAYS',
                Duration = 5,
                Affects = {
                    Regen = {
                        Add = 10,
                        Mult = 1.0,   #bp.RegenPerSecond or 0.1,
                        #Ceil = bp.RegenCeiling,
                        #Floor = bp.RegenFloor,
                    },
                    #MaxHealth = {
                    #    Add = 0,
                    #    Mult = bp.MaxHealthFactor or 1.0,
                    #    DoNoFill = true,
                    #},                        
                },
            }
        end

        table.insert( self.ShieldEffectsBag, CreateAttachedEmitter( self, 'UEC0001', self:GetArmy(), '/effects/emitters/seraphim_regenerative_aura_01_emit.bp' ) )
        self.RegenThreadHandle = self:ForkThread(self.RegenBuffThread)

    end,









}

TypeClass = UEC0001