#****************************************************************************
#**
#**  File     :  /cdimage/units/URS0304/URS0304_script.lua
#**  Author(s):  John Comes, David Tomandl, Jessica St. Croix
#**
#**  Summary  :  Cybran Strategic Missile Submarine Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local CSubUnit = import('/lua/cybranunits.lua').CSubUnit
local CybranWeapons = import('/lua/cybranweapons.lua')

local CIFMissileLoaWeapon = CybranWeapons.CIFMissileLoaWeapon
local CIFMissileStrategicWeapon = CybranWeapons.CIFMissileStrategicWeapon
local CANTorpedoLauncherWeapon = CybranWeapons.CANTorpedoLauncherWeapon
local CAAMissileNaniteWeapon = CybranWeapons.CAAMissileNaniteWeapon

URS0304 = Class(CSubUnit) {
    DeathThreadDestructionWaitTime = 0,
    Weapons = {
        #NukeMissile = Class(CIFMissileStrategicWeapon){},
        CruiseMissile = Class(CIFMissileLoaWeapon){},
        Torpedo01 = Class(CANTorpedoLauncherWeapon){},
        Torpedo02= Class(CANTorpedoLauncherWeapon){},
        AntiAirMissile = Class(CAAMissileNaniteWeapon) {},
    },

    OnStopBeingBuilt = function(self, builder, layer)
        CSubUnit.OnStopBeingBuilt(self,builder,layer)
        if(self:GetCurrentLayer() == 'Water') then
			# Enable weapon
			self:SetWeaponEnabledByLabel('AntiAirMissile', true)
			self:SetWeaponEnabledByLabel('CruiseMissile', false)
        elseif (self:GetCurrentLayer() == 'UnderWater') then
			# Disable Weapon
			self:SetWeaponDisableByLabel('AntiAirMissile', false)
			self:SetWeaponEnabledByLabel('CruiseMissile', true)
       end
       self.WeaponsEnabled = true
    end,



    OnMotionVertEventChange = function( self, new, old )
        CSubUnit.OnMotionVertEventChange(self, new, old)
        if new == 'Top' then
			self:SetWeaponEnabledByLabel('AntiAirMissile', true)
			self:SetWeaponEnabledByLabel('CruiseMissile', false)
        elseif new == 'Down' then
			self:SetWeaponEnabledByLabel('AntiAirMissile', false)
			self:SetWeaponEnabledByLabel('CruiseMissile', true)
        end
    end,

}

TypeClass = URS0304
