#****************************************************************************
#**
#**  File     :  /cdimage/units/XRB3301/XRB3301_script.lua
#**  Author(s):  Dru Staltman, Ted Snook
#**
#**  Summary  :  Cybran Vision unit thing
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************
local CRadarUnit = import('/lua/cybranunits.lua').CRadarUnit
local VizMarker = import('/lua/sim/VizMarker.lua').VizMarker
local CSoothSayerAmbient = import('/lua/EffectTemplates.lua').CSoothSayerAmbient
local EffectUtil = import('/lua/EffectUtilities.lua')

XRB3301 = Class(CRadarUnit) {   
    IntelEffects = {
        {
            Bones = { 'Emitter', },
            Offset = { 0, 0, 4, },
            Type = 'Jammer01',
        },
    },
    
    OnStopBeingBuilt = function(self)
        CRadarUnit.OnStopBeingBuilt(self)
        if self.OmniEffectsBag then
            for k, v in self.OmniEffectsBag do
                v:Destroy()
            end
        end
		self.OmniEffectsBag = {}
		
        for k, v in CSoothSayerAmbient do
            table.insert( self.OmniEffectsBag, CreateAttachedEmitter(self, 'XRB3301', self:GetArmy(), v) )
        end        
        
      
    end,
    


    OnIntelEnabled = function(self)
        CRadarUnit.OnIntelEnabled(self)
        self:SetMaintenanceConsumptionActive()
  	if self.OmniEffectsBag then
                for k, v in self.OmniEffectsBag do
                    v:Destroy()
                end
		        self.OmniEffectsBag = {}
		    end
            for k, v in CSoothSayerAmbient do
                table.insert( self.OmniEffectsBag, CreateAttachedEmitter(self, 'XRB3301', self:GetArmy(), v) )
         end  	            

    end,

    OnIntelDisabled = function(self)
        CRadarUnit.OnIntelDisabled(self)

            if self.OmniEffectsBag then
                for k, v in self.OmniEffectsBag do
                    v:Destroy()
                end
		        self.OmniEffectsBag = {}
		    end
            #ChangeState( self, self.ContractingVision )

    end,
    


    OnKilled = function(self, instigator, type, overkillRatio)
        CRadarUnit.OnKilled(self, instigator, type, overkillRatio)

    end,

}

TypeClass = XRB3301