#****************************************************************************
#**
#**  File     :  /cdimage/units/XSS0203/XSS0203_script.lua
#**
#**  Summary  :  Seraphim Attack Sub Script
#**
#**  Copyright  2007 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************
local SSubUnit = import('/lua/seraphimunits.lua').SSubUnit
local SWeapons = import('/lua/seraphimweapons.lua')

local SANUallCavitationTorpedo = SWeapons.SANUallCavitationTorpedo
local SAMElectrumMissileDefense = import('/lua/seraphimweapons.lua').SAMElectrumMissileDefense
local SDFAjelluAntiTorpedoDefense = SWeapons.SDFAjelluAntiTorpedoDefense

XSS0203 = Class(SSubUnit) {
    DeathThreadDestructionWaitTime = 0,
    Weapons = {
        Torpedo01 = Class(SANUallCavitationTorpedo) {},
        AntiMissile01 = Class(SAMElectrumMissileDefense) {},
        AntiTorpedo = Class(SDFAjelluAntiTorpedoDefense) {},
    },

    OnStopBeingBuilt = function(self,builder,layer)
        SSubUnit.OnStopBeingBuilt(self,builder,layer)
        if layer == 'Water' then
			self:SetWeaponEnabledByLabel('AntiMissile01', true)
           		self:AddCommandCap('RULEUCC_CallTransport')
        else
			self:SetWeaponEnabledByLabel('AntiMissile01', false)
     			self:RemoveCommandCap('RULEUCC_CallTransport')
        end
    end,
    
    OnMotionVertEventChange = function( self, new, old )
        SSubUnit.OnMotionVertEventChange(self, new, old)
        if new == 'Top' then
			self:SetWeaponEnabledByLabel('AntiMissile01', true)
           		self:AddCommandCap('RULEUCC_CallTransport')
        elseif new == 'Down' then
			self:SetWeaponEnabledByLabel('AntiMissile01', false)
     			self:RemoveCommandCap('RULEUCC_CallTransport')
        end
    end,




}
TypeClass = XSS0203